

- Don't look up more pages than we're going to use

- Don't test page->index until we've locked the page

- Check for the cursor wrapping at the end of the mapping.

Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/mm/truncate.c |   12 +++++-------
 1 files changed, 5 insertions(+), 7 deletions(-)

diff -puN mm/truncate.c~invalidate-range-of-pages-after-direct-io-write-fix mm/truncate.c
--- 25/mm/truncate.c~invalidate-range-of-pages-after-direct-io-write-fix	2005-02-22 18:16:09.000000000 -0800
+++ 25-akpm/mm/truncate.c	2005-02-22 18:16:09.000000000 -0800
@@ -263,18 +263,14 @@ int invalidate_inode_pages2_range(struct
 	pagevec_init(&pvec, 0);
 	next = start;
 	while (next <= end &&
-	       !ret && pagevec_lookup(&pvec, mapping, next, PAGEVEC_SIZE)) {
+	       !ret && pagevec_lookup(&pvec, mapping, next,
+			min(end - next, (pgoff_t)PAGEVEC_SIZE - 1) + 1)) {
 		for (i = 0; !ret && i < pagevec_count(&pvec); i++) {
 			struct page *page = pvec.pages[i];
 			int was_dirty;
 
-			if (page->index > end) {
-				next = page->index;
-				break;
-			}
-
 			lock_page(page);
-			if (page->mapping != mapping) {	/* truncate race? */
+			if (page->mapping != mapping || page->index > end) {
 				unlock_page(page);
 				continue;
 			}
@@ -310,6 +306,8 @@ int invalidate_inode_pages2_range(struct
 		}
 		pagevec_release(&pvec);
 		cond_resched();
+		if (next == 0)
+			break;		/* The pgoff_t wrapped */
 	}
 	return ret;
 }
_
